# # # # # # # # # # # # # # # # # #
#                                 #
# This class defines the compiler #
#                                 #
# # # # # # # # # # # # # # # # # #

class Compiler
  
  def initialize()
    puts "> > JiPi to Ruby Translater v 0.1 < <"
    puts "Please enter the name of your source code file:"
    print "[filename] "
    @filename = gets.strip.split(".")[0]
    @sourcecode = Array.new
    @newcode = Array.new
    @error = false
    @errorcodes = Array.new
    puts "The translater will now evaluate the code and try to build a Ruby file."
  end
  
  def readFile()
    @sourcecode = IO.readlines("#{@filename}.jp")
  end
  
  def tokenize()
    no = 1
    @sourcecode.each do |line|
      tokens = Array.new
      token = String.new
      quot = false
      line.split(//).each do |char|
        if quot == true
          if char =~ /"/
            token << char
            tokens.push(token)
            token = String.new
            quot = false
          else
            token << char
          end
        else
          if char =~ /\s/
            if token.length > 0
              tokens.push(token)
              token = String.new
            end
          elsif char =~ /[A-Z]|[a-z]/
            if token.length == 0
              token = char
            elsif token =~ /[A-Z]|[a-z]/
              token << char
            else
              tokens.push(token)
              token = char
            end
          elsif char =~ /(\*)|(\+)|(-)|(\/)|<|>/
            if token.length > 0
              tokens.push(token)
              token = char
            elsif token.length == 0
              token = char
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault")
            end
          elsif char =~ /\(|\)|\[|\]|\,/
            if token.length > 0
              tokens.push(token)
              token = char
            elsif token.length == 0
              token = char
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault")
            end
          elsif char =~ /\=/
            if token =~ /\=|<|>/
              token << char
            elsif token.length > 0
              tokens.push(token)
              token = char
            elsif token.length == 0
              token = char
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault")
            end
          elsif char =~ /\d/
            if token =~ /\d+\.*/
              token << char
            elsif token.length > 0
              tokens.push(token)
              token = char
            elsif token.length == 0
              token = char
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault")      
            end
          elsif char =~ /\./
            if token =~ /\d+/
              token << char
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault")      
            end
          elsif char =~ /"/
            if token.length > 0
              tokens.push(token)
              token = char
              quot = true
            elsif token.length == 0
              token = char
              quot = true
            else
              @error = true
              @errorcodes.push("Line #{no}: Syntactical fault") 
            end
          else
            @error = true
            @errorcodes.push("Line #{no}: Syntactical fault")      
          end
        end
      end
      if token.length > 0
        tokens.push(token)
      end
      @newcode.push(tokens)
      no = no + 1
    end
  end

  def checkList(list, no)
    comma = false
    list.each do |token|
      if comma == false
        if token =~ /"\w+"/
          comma = true
        elsif token =~ /[A-Za-z]+/
          comma = true
        elsif token =~ /[0-9]+(\.([0-9])*){0,1}/
          comma = true
        else
          @error = true
          @errorcodes.push("Line #{no}: Unallowed token sequence inside list")
        end
      else
        if token == ','
          comma = false
        else
          @error = true
          @errorcodes.push("Line #{no}: Unallowed token sequence inside list")
        end
      end
    end
    if comma == false and list.length > 0
      @error = true
      @errorcodes.push("Line #{no}: Unallowed token sequence inside list")
    end
  end
  
  def analyzeLine()
    no = 1
    @newcode.each do |line|
      term = false
      paranthesis = 0

    #checking 'if'/'elseif' lines
      if line[0] == 'if' or line[0] == 'elseif'
        compare = false
        loop = 0
        line.each do |token|
          if term == true	#should be a variable or value
            if token =~ /\(/
              paranthesis = paranthesis + 1
            elsif token =~ /[A-Za-z]+/
              term = false
            elsif token =~ /[0-9]+(\.([0-9])*){0,1}/
              term = false
            else
              @error = true
              @errorcodes.push("Line #{no}: Faulty if statment definition")
            end
          elsif term == false	#should be some kind of operator
            if token =~ /\)/
              paranthesis = paranthesis - 1
            elsif token =~ /<|>|<=|>=|==/
              if paranthesis == 0
                compare = true
                term = true
              else
                @error = true
                @errorcodes.push("Line #{no}: Comparing tokens can't be used inside paranthesis")
              end
            elsif token =~ /(\*)|(\+)|(-)|(\/)/
              term = true
            elsif token =~ /(if)|(elseif)/ and loop == 0
              term = true
            else
              @error = true
              @errorcodes.push("Line #{no}: Faulty if statment definition")
            end 
          end
          loop = loop + 1
        end
        if compare == false
          @error = true
          @errorcodes.push("Line #{no}: Missing boolean expression")
        elsif term == true
          @error = true
          @errorcodes.push("Line #{no}: Line ends with operator")
        end

    #checking 'else'/'end' lines
      elsif line[0] == 'else' or line[0] == 'end'
        if line.length > 1
          @error = true
          @errorcodes.push("Line #{no}: Should only contain one token")
        end
    
    #checking 'for' lines
      elsif line[0] == 'for'
        if line.join =~ /for[A-Za-z]+in[A-Za-z]+/
          #no error
        else
          @error == true
          @errorcodes.push("Line #{no}: Faulty for statement definition")
        end

    #checking 'function' lines
      elsif line[0] == 'function'
        if line.join =~ /function[A-Za-z]+\((([A-Za-z])|([A-Za-z](\,[A-Za-z])*))*\)/
          #no error
        else
          @error = true
          @errorcodes.push("Line #{no}: Faulty function definition")
        end

    #checking assignment lines
      elsif line[0] =~ /[A-Za-z]+/ and line[1] == '='
        loop = 0
        bracket = false
        list = Array.new
        line.each do |token|
          if term == false	#should be a variable or value
            if bracket == true
              if token == ']'
                checkList(list, no)
                bracket = false
              else
                list.push(token)
              end
            else
              if token == '('
               paranthesis = paranthesis + 1
              elsif token =~ /"\w+"/
                term = true
              elsif token =~ /[A-Za-z]+/
                term = true
              elsif token =~ /[0-9]+(\.([0-9])*){0,1}/
                term = true
              elsif token == '['
                bracket = true
              else
                @error = true
                @errorcodes.push("Line #{no}: Faulty assignment line")
              end
            end
          elsif term == true	#should be some kind of operator
            if token =~ /\)/
              paranthesis = paranthesis - 1
            elsif token =~ /(\*)|(\+)|(-)|(\/)/
              term = false
            elsif token == '='
              if loop != 1
                @error = true
                @errorcodes.push("Line #{no}: Assignment line can only contain one '=' token")
              end
              term = false
            else
              @error = true
              @errorcodes.push("Line #{no}: Faulty assignment line")
            end 
          end
          loop = loop + 1
        end
        if term == false
          if line.last == ']'
            #no error
          else
            @error = true
            @errorcodes.push("Line #{no}: Line ends with operator")
          end
        end

    #checking functioncall lines
      elsif line.join =~ /[A-Za-z]+\((([A-Za-z0-9])|([A-Za-z0-9](\,[A-Za-z0-9])*))*\)/
        #no error

    #clearing empty lines
      elsif line.length == 0
        #no error

    #if non above fited throw error
      else
        @error = true
        @errorcodes.push("Line #{no}: Unallowed begining of line")
      end
      if paranthesis != 0
        @error = true
        @errorcodes.push("Line #{no}: Non-matching number of parenthesis")
      end
      no = no + 1
    end
  end

  def analyzeBig()
    no = 1
    @newcode.each do |line|
      #Kolla alla pbrjade satser avslutas
      #Kolla att anvnda variabler r deklarerade (har vrde)
        #Namespaces??
      no = no + 1
    end
  end
  
  def evaluate()
    no = 1
    @newcode.each do |line|
      #verstt raden, keywords mm
      #hll koll p @level s indentering blir rtt
      #skriv till fil (appenda rad fr rad?)
      no = no + 1
    end
  end

  def checkError()
    @error
  end

  def showError()
    @errorcodes.each do |error|
      puts error
    end
  end

  def exit()
    puts "The translation finished without errors"
    puts "The built ruby source file is namned #{@filename}.rb"
    print "Exit? "
    gets
  end
end
